diff --git a/sysdeps/mach/hurd/Makefile b/sysdeps/mach/hurd/Makefile
index f43e92bab3..d5584930a1 100644
--- a/sysdeps/mach/hurd/Makefile
+++ b/sysdeps/mach/hurd/Makefile
@@ -197,10 +197,6 @@ ifeq (hurd, $(subdir))
 sysdep_routines += cthreads
 endif
 
-ifeq (elf, $(subdir))
-sysdep-dl-routines += dl-tls-initialized
-endif
-
 ifeq (io, $(subdir))
 sysdep_routines += f_setlk close_nocancel close_nocancel_nostatus \
 		   fcntl_nocancel open_nocancel openat_nocancel read_nocancel \
diff --git a/sysdeps/mach/hurd/i386/dl-tls-initialized.c b/sysdeps/mach/hurd/i386/dl-tls-initialized.c
deleted file mode 100644
index 493ec2396c..0000000000
--- a/sysdeps/mach/hurd/i386/dl-tls-initialized.c
+++ /dev/null
@@ -1,21 +0,0 @@
-/* Determine whether TLS is initialized, for i386/Hurd.
-   Copyright (C) 1995-2023 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <https://www.gnu.org/licenses/>.  */
-
-#ifndef SHARED
-unsigned short __init1_desc;
-#endif
diff --git a/sysdeps/mach/hurd/i386/tls.h b/sysdeps/mach/hurd/i386/tls.h
index 0ac8917a95..694be9fd64 100644
--- a/sysdeps/mach/hurd/i386/tls.h
+++ b/sysdeps/mach/hurd/i386/tls.h
@@ -69,6 +69,18 @@ _Static_assert (offsetof (tcbhead_t, __private_ss) == 0x30,
                   |  (desc->high_word & 0xff000000));			      \
   })
 
+/* Return 1 if TLS is not initialized yet.  */
+#ifndef SHARED
+extern unsigned short __init1_desc;
+#define __HURD_DESC_INITIAL(gs, ds) ((gs) == (ds) || (gs) == __init1_desc)
+#else
+#define __HURD_DESC_INITIAL(gs, ds) ((gs) == (ds))
+#endif
+
+#define __LIBC_NO_TLS()							      \
+  ({ unsigned short ds, gs;						      \
+     asm ("movw %%ds,%w0; movw %%gs,%w1" : "=q" (ds), "=q" (gs));	      \
+     __builtin_expect(__HURD_DESC_INITIAL(gs, ds), 0); })
 #endif
 
 /* The TCB can have any size and the memory following the address the
@@ -113,28 +125,6 @@ _Static_assert (offsetof (tcbhead_t, __private_ss) == 0x30,
 
 # define HURD_SEL_LDT(sel) (__builtin_expect ((sel) & 4, 0))
 
-#ifndef SHARED
-extern unsigned short __init1_desc;
-# define __HURD_DESC_INITIAL(gs, ds) ((gs) == (ds) || (gs) == __init1_desc)
-#else
-# define __HURD_DESC_INITIAL(gs, ds) ((gs) == (ds))
-#endif
-
-#if !defined (SHARED) || IS_IN (rtld)
-/* Return 1 if TLS is not initialized yet.  */
-extern inline bool __attribute__ ((unused))
-__LIBC_NO_TLS (void)
-{
-  unsigned short ds, gs;
-  asm ("movw %%ds, %w0\n"
-       "movw %%gs, %w1"
-       : "=q" (ds), "=q" (gs));
-  return __glibc_unlikely (__HURD_DESC_INITIAL (gs, ds));
-}
-
-/* Code to initially initialize the thread pointer.  This might need
-   special attention since 'errno' is not yet available and if the
-   operation can cause a failure 'errno' must not be touched.  */
 static inline bool __attribute__ ((unused))
 _hurd_tls_init (tcbhead_t *tcb)
 {
@@ -183,10 +173,11 @@ out:
   return success;
 }
 
-# define TLS_INIT_TP(descr) _hurd_tls_init ((tcbhead_t *) (descr))
-#else /* defined (SHARED) && !IS_IN (rtld) */
-# define __LIBC_NO_TLS() 0
-#endif
+/* Code to initially initialize the thread pointer.  This might need
+   special attention since 'errno' is not yet available and if the
+   operation can cause a failure 'errno' must not be touched.  */
+# define TLS_INIT_TP(descr) \
+    _hurd_tls_init ((tcbhead_t *) (descr))
 
 # if __GNUC_PREREQ (6, 0)
 
diff --git a/sysdeps/mach/hurd/x86/init-first.c b/sysdeps/mach/hurd/x86/init-first.c
index 89a5f44cdd..48c330ec06 100644
--- a/sysdeps/mach/hurd/x86/init-first.c
+++ b/sysdeps/mach/hurd/x86/init-first.c
@@ -40,6 +40,13 @@ extern char **_dl_argv;
 
 #ifndef SHARED
 static tcbhead_t __init1_tcbhead;
+# ifndef __x86_64__
+unsigned short __init1_desc;
+# endif
+#endif
+
+#ifdef __x86_64__
+unsigned char __libc_tls_initialized;
 #endif
 
 /* Things that want to be run before _hurd_init or much anything else.
@@ -159,7 +166,9 @@ first_init (void)
   _hurd_tls_init (&__init1_tcbhead);
 
   /* Make sure __LIBC_NO_TLS () keeps evaluating to 1.  */
-# ifndef __x86_64__
+# ifdef __x86_64__
+  __libc_tls_initialized = 0;
+# else
   asm ("movw %%gs,%w0" : "=m" (__init1_desc));
 # endif
 #endif
diff --git a/sysdeps/mach/hurd/x86_64/dl-tls-initialized.c b/sysdeps/mach/hurd/x86_64/dl-tls-initialized.c
deleted file mode 100644
index d0766f955d..0000000000
--- a/sysdeps/mach/hurd/x86_64/dl-tls-initialized.c
+++ /dev/null
@@ -1,21 +0,0 @@
-/* Determine whether TLS is initialized, for x86_64/Hurd.
-   Copyright (C) 1995-2023 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <https://www.gnu.org/licenses/>.  */
-
-#if !defined (SHARED) || IS_IN (rtld)
-unsigned short __libc_tls_initialized;
-#endif
diff --git a/sysdeps/mach/hurd/x86_64/tls.h b/sysdeps/mach/hurd/x86_64/tls.h
index 2b7135f635..e5c6f82acd 100644
--- a/sysdeps/mach/hurd/x86_64/tls.h
+++ b/sysdeps/mach/hurd/x86_64/tls.h
@@ -68,6 +68,10 @@ _Static_assert (offsetof (tcbhead_t, stack_guard) == 0x28,
 _Static_assert (offsetof (tcbhead_t, __private_ss) == 0x70,
                 "split stack pointer offset");
 
+extern unsigned char __libc_tls_initialized;
+
+# define __LIBC_NO_TLS() __builtin_expect (!__libc_tls_initialized, 0)
+
 /* The TCB can have any size and the memory following the address the
    thread pointer points to is unspecified.  Allocate the TCB there.  */
 # define TLS_TCB_AT_TP	1
@@ -83,6 +87,8 @@ _Static_assert (offsetof (tcbhead_t, __private_ss) == 0x70,
 # define TCB_ALIGNMENT	64
 
 
+# define TLS_INIT_TP(descr) _hurd_tls_init ((tcbhead_t *) (descr))
+
 # define THREAD_SELF							\
   (*(tcbhead_t * __seg_fs *) offsetof (tcbhead_t, tcb))
 /* Read member of the thread descriptor directly.  */
@@ -168,10 +174,6 @@ _hurd_tls_new (thread_t child, tcbhead_t *tcb)
                              i386_FSGS_BASE_STATE_COUNT);
 }
 
-# if !defined (SHARED) || IS_IN (rtld)
-extern unsigned char __libc_tls_initialized;
-#  define __LIBC_NO_TLS() __builtin_expect (!__libc_tls_initialized, 0)
-
 static inline bool __attribute__ ((unused))
 _hurd_tls_init (tcbhead_t *tcb)
 {
@@ -195,12 +197,6 @@ _hurd_tls_init (tcbhead_t *tcb)
   return err == 0;
 }
 
-#  define TLS_INIT_TP(descr) _hurd_tls_init ((tcbhead_t *) (descr))
-# else /* defined (SHARED) && !IS_IN (rtld) */
-#  define __LIBC_NO_TLS() 0
-# endif
-
-
 
 /* Global scope switch support.  */
 # define THREAD_GSCOPE_FLAG_UNUSED 0